### 实验七 七段数码管显示

#### 数码管显示的原理

![image-20221205133419490](E:\派哟项目\Hexbot项目\HEXBot_使用手册\ESP32使用手册\实验七 七段数码管显示\数码管.png)

它的原理就是多个LED，点亮组合成不同的数字。

这里我们是由一块TM1637芯片控制一个四位的七段数码管，TM1637 LED数码管驱动芯片，是一种带键盘扫描接口的LED（发光二极管显示器）驱动控制专用电路，内部集成有MCU 数字接口、数据锁存器、LED 高压驱动、键盘扫描等电路。

![image-20221205140234884](E:\派哟项目\Hexbot项目\HEXBot_使用手册\ESP32使用手册\实验七 七段数码管显示\TM1637.png)

安装TM1637对应的库：Crove 4-Digit Display by Seeed Studio

![image-20221205140400481](E:\派哟项目\Hexbot项目\HEXBot_使用手册\ESP32使用手册\实验七 七段数码管显示\TM1637库.png)

#### 程序讲解

**TM1637 tm1637(CLK, DIO);**

设置tm1637数字显示开始

**tm1637.init()**

芯片初始化函数

 **tm1637.point(1);**

小数点开关，1为打开，0为关闭

**tm1637.set(BRIGHT_TYPICAL);**

数码管的亮度设置函数（本质是控制电压来控制数码管里对应led的亮度）

有三种亮度可选BRIGHT_TYPICAL 普通BRIGHT_DARKEST 较暗BRIGHTEST = 7 高亮

烧录以下程序可以看到四位数码管以每秒加一的速度显示

![image-20221205153514915](E:\派哟项目\Hexbot项目\HEXBot_使用手册\ESP32使用手册\实验七 七段数码管显示\LED.png)

#### 程序源码

```
#include "TM1637.h"

#define CLK  32 //Set the CLK pin connection to the display

#define DIO  33 //Set the DIO pin connection to the display

TM1637 tm1637(CLK, DIO); //set up the 4-Digit Display.

int numCounter = 0;

bool dian = false;



void setup() {

 // put your setup code here, to run once:

 tm1637.init();  //芯片引脚初始化

 tm1637.point(1);//小数点开关，1为打开，0为关闭

 tm1637.set(BRIGHT_TYPICAL);//BRIGHT_TYPICAL = 2,BRIGHT_DARKEST = 0,BRIGHTEST = 7;

}



void loop() {

 // put your main code here, to run repeatedly:

 for (numCounter = 0; numCounter < 9999; numCounter++) //Iterate numCounter

 {

  tm1637.display(0, (numCounter / 1000%10));

  tm1637.display(1, (numCounter / 100%10));

  tm1637.display(2, (numCounter / 10%10));

  tm1637.display(3, (numCounter % 10));

  dian = !dian;

  tm1637.point(dian);

  delay(200);

 }

}
```

